/**
 * 
 */
package featureide_ui.editors.configuration;

import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

import featureide_core.model.configuration.Configuration;
import featureide_core.model.configuration.TreeElement;

public class ConfigurationContentProvider implements
		IStructuredContentProvider, ITreeContentProvider {

	private Configuration configuration;

	public void inputChanged(Viewer v, Object oldInput, Object newInput) {
		configuration = (Configuration) newInput;
	}

	public void dispose() {
	}

	public Object[] getElements(Object parent) {
		if (parent == null)
			return new String[] { "Loading..." };
		if (parent == configuration)
			return new TreeElement[] { configuration.getRoot() };

		return getChildren(parent);
	}

	public Object getParent(Object child) {
		if (child instanceof TreeElement) {
			return ((TreeElement) child).getParent();
		}
		return null;
	}

	public Object[] getChildren(Object parent) {
		if (parent instanceof TreeElement) {
			return ((TreeElement) parent).getChildren();
		}
		return new Object[0];
	}

	public boolean hasChildren(Object parent) {
		if (parent instanceof TreeElement)
			return ((TreeElement) parent).hasChildren();
		return false;
	}

}