/**
 * 
 */
package featureide_ui.editors.configuration;

import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.swt.graphics.Image;

import featureide_core.model.configuration.SelectableFeature;
import featureide_core.model.configuration.Selection;
import featureide_ui.FeatureModelUIActivator;

public class ConfigurationLabelProvider extends LabelProvider {

	public ConfigurationLabelProvider() {
		IMAGE_UNDEFINED = FeatureModelUIActivator.getImageDescriptor(
				"icons/undefined.ico").createImage();

		IMAGE_SELECTED = FeatureModelUIActivator.getImageDescriptor(
				"icons/selected.ico").createImage();

		IMAGE_DESELECTED = FeatureModelUIActivator.getImageDescriptor(
				"icons/deselected.ico").createImage();

		IMAGE_ASELECTED = FeatureModelUIActivator.getImageDescriptor(
				"icons/aselected.ico").createImage();

		IMAGE_ADESELECTED = FeatureModelUIActivator.getImageDescriptor(
				"icons/adeselected.ico").createImage();
		;
	}

	public final Image IMAGE_UNDEFINED, IMAGE_SELECTED, IMAGE_DESELECTED,
			IMAGE_ASELECTED, IMAGE_ADESELECTED;

	public String getText(Object o) {
		return o.toString();
	}

	public Image getImage(Object o) {
		if (!(o instanceof SelectableFeature))
			return null;
		SelectableFeature feature = (SelectableFeature) o;
		if (feature.getAutomatic() != Selection.UNDEFINED)
			return feature.getAutomatic() == Selection.SELECTED ? IMAGE_ASELECTED
					: IMAGE_ADESELECTED;
		if (feature.getManual() == Selection.UNDEFINED)
			return IMAGE_UNDEFINED;
		return feature.getManual() == Selection.SELECTED ? IMAGE_SELECTED
				: IMAGE_DESELECTED;
	}

	@Override
	public void dispose() {
		IMAGE_UNDEFINED.dispose();
		IMAGE_SELECTED.dispose();
		IMAGE_DESELECTED.dispose();
		IMAGE_ASELECTED.dispose();
		IMAGE_ADESELECTED.dispose();
		super.dispose();
	}
}