package featureide_ui.editors.grammar.actions;

import org.eclipse.gef.ui.parts.GraphicalViewerImpl;

import featureide_core.model.FeatureModel;

public class AlternativeAction extends SingleSelectionAction {

	public static String ID = "featureide.alternative";

	private final FeatureModel featureModel;

	public AlternativeAction(GraphicalViewerImpl viewer, FeatureModel featureModel) {
		super("ALTERNATIVE", viewer);
		this.featureModel = featureModel;
	}

	@Override
	public void run() {
		feature.changeToAlternative();
		featureModel.handleModelDataChanged();
	}

	@Override
	protected void updateProperties() {
		boolean alt = feature.isAlternative();
		setEnabled(connectionSelected && !alt);
		setChecked(connectionSelected && alt);
	}

}
