package featureide_ui.editors.grammar.actions;

import org.eclipse.gef.ui.parts.GraphicalViewerImpl;

import featureide_core.model.FeatureModel;

public class AndAction extends SingleSelectionAction {

	public static String ID = "featureide.and";

	private final FeatureModel featureModel;
	
	public AndAction(GraphicalViewerImpl viewer, FeatureModel featureModel) {
		super("AND", viewer);
		this.featureModel = featureModel;
	}

	@Override
	public void run() {
		feature.changeToAnd();
		featureModel.handleModelDataChanged();
	}

	@Override
	protected void updateProperties() {
		boolean and = feature.isAnd();
		setEnabled(connectionSelected && !and);
		setChecked(connectionSelected && and);
	}

}
