package featureide_ui.editors.grammar.actions;

import org.eclipse.gef.ui.parts.GraphicalViewerImpl;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.ISharedImages;
import org.eclipse.ui.PlatformUI;

import featureide_core.model.Feature;
import featureide_core.model.FeatureModel;

public class CreateLayerAction extends SingleSelectionAction {

	public static String ID = "featureide.createlayer";

	private static ImageDescriptor createImage = PlatformUI.getWorkbench()
			.getSharedImages().getImageDescriptor(
					ISharedImages.IMG_TOOL_NEW_WIZARD);

	private final FeatureModel featureModel;

	public CreateLayerAction(GraphicalViewerImpl viewer, FeatureModel featureModel) {
		super("Create new layer", viewer);
		setImageDescriptor(createImage);
		this.featureModel = featureModel;
	}

	@Override
	public void run() {
		int number = 0;
		while (featureModel.getFeatureNames().contains("NewLayer" + ++number));
		Feature newFeature = new Feature("NewLayer" + number);
		featureModel.addFeature(newFeature);
		feature.addChild(newFeature);
		featureModel.handleModelDataChanged();
	}
	
	@Override
	protected boolean isValidSelection(IStructuredSelection selection) {
		return super.isValidSelection(selection) && getSelectedFeature().isCompound();
	}

	@Override
	protected void updateProperties() {
		setEnabled(!connectionSelected);
		setChecked(false);
	}

}
