package featureide_ui.editors.grammar.actions;

import org.eclipse.gef.ui.parts.GraphicalViewerImpl;

import featureide_core.model.FeatureModel;

public class MandantoryAction extends SingleSelectionAction {

	public static String ID = "featureide.mandantory";

	private final FeatureModel featureModel;

	public MandantoryAction(GraphicalViewerImpl viewer, FeatureModel featureModel) {
		super("Mandantory", viewer);
		this.featureModel = featureModel;
	}

	@Override
	public void run() {
		feature.setMandatory(!feature.isMandatory());
		setChecked(feature.isMandatory());
		featureModel.handleModelDataChanged();
	}

	@Override
	protected void updateProperties() {
		setEnabled(!feature.isRoot() && feature.getParent().isAnd());
		setChecked(feature.isMandatory());
	}

}
