package featureide_ui.editors.grammar.commands.renaming;

import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.jface.viewers.CellEditor;

import featureide_ui.editors.grammar.GUIDefaults;
import featureide_ui.editors.grammar.figures.FeatureFigure;

public class FeatureCellEditorLocator implements CellEditorLocator, GUIDefaults {

	private FeatureFigure figure;

	public FeatureCellEditorLocator(FeatureFigure figure) {
		this.figure = figure;
	}

	public void relocate(CellEditor celleditor) {
		Rectangle labelBounds = figure.getLabelBounds();
		Rectangle bounds = labelBounds.getCopy();
		figure.translateToAbsolute(bounds);
		
		bounds.width = Math.max(bounds.width, CELL_EDITOR_MINSIZE.width);
		bounds.width += CELL_EDITOR_INSETS.getWidth();
		bounds.x += (labelBounds.width - bounds.width) / 2;

		bounds.height = Math.max(bounds.height, CELL_EDITOR_MINSIZE.height);
		bounds.height += CELL_EDITOR_INSETS.getHeight();
		bounds.y += (labelBounds.height - bounds.height) / 2;
		
		celleditor.getControl().setBounds(bounds.x, bounds.y, bounds.width, bounds.height);
	}

}
