package featureide_ui.editors.grammar.editparts;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.gef.editparts.AbstractGraphicalEditPart;

import featureide_core.model.Constraint;
import featureide_core.model.PropertyConstants;
import featureide_ui.editors.grammar.figures.ConstraintFigure;

/**
 * An editpart to display cross-tree constraints below the feature diagram.
 * 
 * @author Thomas Thm
 *
 */
public class ConstraintEditPart extends AbstractGraphicalEditPart implements PropertyConstants, PropertyChangeListener {
	
	public ConstraintEditPart(Constraint constraint) {
		super();
		setModel(constraint);
	}
	
	public Constraint getConstraintModel() {
		return (Constraint) getModel();
	}
	
	public ConstraintFigure getConstraintFigure() {
		return (ConstraintFigure) getFigure();
	}
	
	@Override
	protected IFigure createFigure() {
		ConstraintFigure figure = new ConstraintFigure(getConstraintModel());
		return figure;
	}

	@Override
	protected void createEditPolicies() {
//		FeatureModel modelData = ((ModelEditPart) getParent()).getModelData();
//		installEditPolicy(EditPolicy.DIRECT_EDIT_ROLE, new FeatureDirectEditPolicy(modelData, getConstraintModel()));
	}
	
//	private DirectEditManager manager;
//	
//	@Override
//	public void performRequest(Request request) {
//		if (request.getType() == RequestConstants.REQ_DIRECT_EDIT) {
//			if (manager == null)
//				manager = new FeatureLabelEditManager(this, TextCellEditor.class,
//						new FeatureCellEditorLocator((FeatureFigure) getFigure()));
//			manager.show();
//		}
//		else if (request.getType() == RequestConstants.REQ_OPEN) {
//			Feature feature = getConstraintModel();
//			feature.setMandatory(!feature.isMandatory());
//
//			ModelEditPart parent = (ModelEditPart) getParent();
//			FeatureModel modelData = parent.getModelData();
//			modelData.handleModelDataChanged();
//		}
//	}

	@Override
	public void activate() {
		getConstraintModel().addListener(this);
		super.activate();
	}
	
	@Override
	public void deactivate() {
		super.deactivate();
		getConstraintModel().removeListener(this);
	}

	/*
	 * (non-Javadoc)
	 * @see java.beans.PropertyChangeListener#propertyChange(java.beans.PropertyChangeEvent)
	 */
	@SuppressWarnings("unchecked")
	public void propertyChange(PropertyChangeEvent event) {
		String prop = event.getPropertyName();
		if (prop.equals(LOCATION_CHANGED)) {
			getConstraintFigure().setLocation((Point) event.getNewValue());
		}
//		else if (prop.equals(NAME_CHANGED)) {
//			getConstraintFigure().setName(getConstraintModel().getName());
//			getConstraintModel().setSize(getConstraintFigure().getSize());
//		}
	}
	
}
