package featureide_ui.editors.grammar.editparts;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;

import featureide_core.model.Constraint;
import featureide_core.model.Feature;
import featureide_core.model.FeatureConnection;
import featureide_core.model.FeatureModel;

/**
 * Creates editparts for given models.
 * 
 * @author Thomas Thm
 *
 */
public class GraphicalEditPartFactory implements EditPartFactory {

	public EditPart createEditPart(EditPart context, Object model) {
		if (model instanceof FeatureModel)
			return new ModelEditPart((FeatureModel) model);
		
		if (model instanceof Feature)
			return new FeatureEditPart((Feature) model);
		
		if (model instanceof FeatureConnection)
			return new ConnectionEditPart((FeatureConnection) model);

		if (model instanceof Constraint)
			return new ConstraintEditPart((Constraint) model);

        return null;
	}

}
