package featureide_ui.editors.grammar.figures;

import org.eclipse.draw2d.Ellipse;
import org.eclipse.draw2d.RotatableDecoration;
import org.eclipse.draw2d.geometry.Point;

import featureide_ui.editors.grammar.GUIDefaults;

/**
 * A decoration for a feature connection that indicates the mandantory property.
 * 
 * @author Thomas Thm
 *
 */
public class CircleDecoration extends Ellipse implements RotatableDecoration, GUIDefaults {
	
	public CircleDecoration(boolean fill) {
		super();
		setForegroundColor(DECORATOR_FOREGROUND);
		setBackgroundColor(fill ? DECORATOR_FOREGROUND : DECORATOR_BACKGROUND);
		setSize(SOURCE_ANCHOR_DIAMETER, SOURCE_ANCHOR_DIAMETER);
	}
	
	@Override
	public void setLocation(Point p) {		
		super.setLocation(p.translate(-SOURCE_ANCHOR_DIAMETER/2, -SOURCE_ANCHOR_DIAMETER/2));
	}
	
	public void setReferencePoint(Point p) {
		//nothing to do because this is a circle
	}

}
