package featureide_ui.editors.grammar.figures.anchors;

import org.eclipse.draw2d.AbstractConnectionAnchor;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Point;

import featureide_core.model.Feature;
import featureide_ui.editors.FeatureUIHelper;

/**
 * Used by the connection to get the position of the small circle.
 * 
 * @author Thomas Thm
 *
 */
public class SourceAnchor extends AbstractConnectionAnchor {
	
	private Feature model;

	public SourceAnchor(IFigure owner, Feature model) {
		super(owner);
		this.model = model;
	}

	public Point getLocation(Point reference) {
		Point ref = FeatureUIHelper.getSourceLocation(model);
		getOwner().translateToAbsolute(ref);
		return ref;
	}
	
}
