package featureide_ui.editors.grammar.figures.anchors;

import org.eclipse.draw2d.AbstractConnectionAnchor;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Point;

import featureide_core.model.Feature;
import featureide_ui.editors.FeatureUIHelper;

/**
 * Used to get the point where all connections from child features end.
 * 
 * @author Thomas Thm
 *
 */
public class TargetAnchor extends AbstractConnectionAnchor {

	private Feature model;

	public TargetAnchor(IFigure owner, Feature model) {
		super(owner);
		this.model = model;
	}
	
	public Point getLocation(Point reference) {
		Point ref = FeatureUIHelper.getTargetLocation(model);
		getOwner().translateToAbsolute(ref);
		return ref;
	}
	
}
