package featureide_ui.editors.grammar.layouts;

import org.eclipse.draw2d.geometry.Point;

import featureide_core.model.Feature;
import featureide_core.model.FeatureModel;
import featureide_ui.editors.FeatureUIHelper;

/**
 * Layouts the features at the feature diagram using a depth first search.
 * 
 * @author Thomas Thm
 *
 */
public class DepthFirstLayout extends FeatureLayoutManager {
	
	public void layout(FeatureModel featureModel) {
		depthFirstLayout(featureModel.getRoot(), 0, LAYOUT_MARGIN_X);
	}

	private int depthFirstLayout(Feature feature, int level, int x) {
		FeatureUIHelper.setLocation(feature,new Point(x, LAYOUT_MARGIN_Y + level*FEATURE_SPACE_Y));
		int newX = x;
		for (Feature child : feature.getChildren()) {
			newX = depthFirstLayout(child, level + 1, newX);
		}
		return Math.max(newX, x + FeatureUIHelper.getSize(feature).width + FEATURE_SPACE_X);
	}

	@Override
	public void setControlSize(int width, int height) {
		//not needed
	}

}
