package featureide_ui.editors.grammar.policies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.DirectEditPolicy;
import org.eclipse.gef.requests.DirectEditRequest;

import featureide_core.model.Feature;
import featureide_core.model.FeatureModel;
import featureide_ui.editors.grammar.GUIDefaults;
import featureide_ui.editors.grammar.commands.FeatureRenamingCommand;

public class FeatureDirectEditPolicy extends DirectEditPolicy implements GUIDefaults {
	
	private final FeatureModel featureModel;

	private final Feature feature;
	
	public FeatureDirectEditPolicy(FeatureModel featureModel, Feature feature) {
		this.featureModel = featureModel;
		this.feature = feature;
	}
	
	@Override
	protected Command getDirectEditCommand(DirectEditRequest request) {
		String newName = (String) request.getCellEditor().getValue();
		return new FeatureRenamingCommand(featureModel, feature.getName(), newName);
	}

	@Override
	protected void showCurrentEditValue(DirectEditRequest request) {
	}
	
}
